<?php
/* WebDirectory RELEASE 2.0.1
 * Copyright (C) 2005 Benjamin Heckmann
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

	//Include classes
	include("class/Logging.class.php");

	//Start php session handler
	session_name("webdirectory");
	session_start();

	//Read configuration file
	if (!@fopen("webdirectory.ini", "r")) exit("SERVER SIDE ERROR: Configuration file not found.");
	else $_SESSION["configuration"] = parse_ini_file("webdirectory.ini", true);
	
	//Set actual instance
	if (isset($_GET["inst"])) $_SESSION["authentication"]["instance"] = $_GET["inst"];
	if (!isset($_GET["inst"]) and !isset($_SESSION["authentication"]["instance"])) $_SESSION["authentication"]["instance"] = "default";

	//Check logfile
	if (!@fopen($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["logFile"], "a+")) $str_loginerror = "SERVER SIDE ERROR: Could not write to logfile.";
	//Check base directory
	if (!is_dir($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["baseDirectory"])) $str_loginerror = "SERVER SIDE ERROR: Base directory not found.";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD>
<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">
<?php	
	//Get list of users for actual instance
	if ($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["authFile"] != "" and !@fopen($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["authFile"], "r")) $str_loginerror = "SERVER SIDE ERROR: Authentication file not found.";
	elseif ($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["authFile"] != "") $arr_instanceuser = parse_ini_file($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["authFile"]);
	
	//Create logging object
	$obj_logging = new Logging($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["logFile"]);

	//Logout user
	if (isset($_GET["logout"])) {
		//Redirect to main dialog
		echo("<meta http-equiv='Refresh' content='0; URL=".$_SERVER["PHP_SELF"]."?inst=".$_SESSION["authentication"]["instance"]."'>");
		//Log user authentication
		$obj_logging->Log("User logged out");
		//Destroy current session
		session_destroy();
	}

	//Search login user in user list and compare passwords
	if ($arr_instanceuser[$_POST["user"]] != "" and $arr_instanceuser[$_POST["user"]] == $_POST["password"]) {
		//Set authentication flag
		$_SESSION["authentication"]["login"] = "AUTHENTICATED";
		//Store username
		$_SESSION["authentication"]["user"] = $_POST["user"];
		//Log user authentication
		$obj_logging->Log("User logged in");
	}
	elseif ($_POST["user"] != "") {
		$str_loginerror = "Login failed. Check username and password.";
	}
	
	//Grant authentication without user login if disabled in configuration
	if ($_SESSION["configuration"][$_SESSION["authentication"]["instance"]]["authFile"] == "")
	{
		$_SESSION["authentication"]["login"] = "AUTHENTICATED";
	}
	
	//Redirect on successful login
	if ($_SESSION["authentication"]["login"] == "AUTHENTICATED" and $str_loginerror == "") {
		echo("<meta http-equiv='Refresh' content='0; URL=webdirectory.php'>");
	}
?>
<TITLE>WebDirectory</TITLE>
<LINK rel="stylesheet" type="text/css" href="webdirectory.css"></HEAD>
<BODY>
<P class="title"><A class="title" href="http://webdirectory.benjaminheckmann.de" target="_blank">WebDirectory 2.0</A></P>
<FORM method="POST" action="<?php echo($_SERVER["PHP_SELF"]) ?>">
<P class="left">
User&nbsp;&nbsp;&nbsp;<INPUT tabIndex="1" type="text" name="user" value="" size="10"><br>
Password&nbsp;&nbsp;&nbsp;<INPUT tabIndex="2" type="password" name="password" value="" size="10"><br><br>
<INPUT tabIndex="3" type="submit" name="login" value="Login">
</P>
</FORM>
<P class="error"><?php echo($str_loginerror) ?></P>
<HR>
</BODY></HTML>